/************************************************************************/
/*                                                                      */
/*    *****                       *****                                 */
/*      *****                   *****                                   */
/*        *****               *****                                     */
/*          *****           *****                                       */
/*  ***************       ***************                               */
/*  *****************   *****************                               */
/*  ***************       ***************                               */
/*          *****           *****           TheNetNode                  */
/*        *****               *****         Portable                    */
/*      *****                   *****       Network                     */
/*    *****                       *****     Software                    */
/*                                                                      */
/* File include/hardware.h (maintained by: ???)                         */
/*                                                                      */
/* This file is part of "TheNetNode" - Software Package                 */
/*                                                                      */
/* Copyright (C) 1998 - 2008 NORD><LINK e.V. Braunschweig               */
/*                                                                      */
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the NORD><LINK ALAS (Allgemeine Lizenz fuer    */
/* Amateurfunk Software) as published by Hans Georg Giese (DF2AU)       */
/* on 13/Oct/1992; either version 1, or (at your option) any later      */
/* version.                                                             */
/*                                                                      */
/* This program is distributed WITHOUT ANY WARRANTY only for further    */
/* development and learning purposes. See the ALAS (Allgemeine Lizenz   */
/* fuer Amateurfunk Software).                                          */
/*                                                                      */
/* You should have received a copy of the NORD><LINK ALAS (Allgemeine   */
/* Lizenz fuer Amateurfunk Software) along with this program; if not,   */
/* write to NORD><LINK e.V., Hinter dem Berge 5, D-38108 Braunschweig   */
/*                                                                      */
/* Dieses Programm ist PUBLIC DOMAIN, mit den Einschraenkungen durch    */
/* die ALAS (Allgemeine Lizenz fuer Amateurfunk Software), entweder     */
/* Version 1, veroeffentlicht von Hans Georg Giese (DF2AU),             */
/* am 13.Oct.1992, oder (wenn gewuenscht) jede spaetere Version.        */
/*                                                                      */
/* Dieses Programm wird unter Haftungsausschluss vertrieben, aus-       */
/* schliesslich fuer Weiterentwicklungs- und Lehrzwecke. Naeheres       */
/* koennen Sie der ALAS (Allgemeine Lizenz fuer Amateurfunk Software)   */
/* entnehmen.                                                           */
/*                                                                      */
/* Sollte dieser Software keine ALAS (Allgemeine Lizenz fuer Amateur-   */
/* funk Software) beigelegen haben, wenden Sie sich bitte an            */
/* NORD><LINK e.V., Hinter dem Berge 5, D-38108 Braunschweig            */
/*                                                                      */
/************************************************************************/

#define TOKENRING                     /* Tokenring-Interface einbinden  */
#define COMKISS                       /* COM2-KISSLINK Anbindung        */
#define VANESSA                       /* Compilieren fuer SEPRAN/PC     */
#define EXTDEV                        /* Externe Devices                */
#define SCC                           /* USCC/DSCC/OSCC                 */
/*#define PAR96*/                     /* PAR96/PICPAR/EPP               */
#define TCP_STACK                     /* Interner TCP-Stack.            */


/************************************************************************/
/* Deaktivierung einzelner Elemente wenn fuer Zielsystem unmoeglich     */
/* (Diese Definitionen duerfen nicht editiert werden.                   */
/************************************************************************/

#define MAX_MAJOR 10

#if defined(MC68K)
#undef EXTDEV
#undef VANESSA
#undef SCC
#undef PAR96
#undef MAX_MAJOR
#define MAX_MAJOR 3
#endif

#if defined(__LINUX__)
#undef EXTDEV
#undef SCC
#undef PAR96
#endif

#if defined(__FALCON__)
#undef  EXTDEV
#undef  VANESSA
#undef  SCC
#undef  PAR96
#endif

/* End of include/hardware.h */
